/*  $Id$

    Part of XPCE
    Designed and implemented by Anjo Anjewierden and Jan Wielemaker
    E-mail: jan@swi.psy.uva.nl

    Copyright (C) 1998 University of Amsterdam. All rights reserved.
*/

:- use_module(library(pce)).

%	call_atom/1
%	Underlying the prove OLE method

call_atom(Atom) :-
	atom_to_term(Atom, Term, _Bindings),
	Term.

%	bind_window(+ClassName, +HWND)
%
%	Underlying the bindWindow OLE method

bind_window(Class, HWND) :-
	new(W, Class),
	send(W, lock_object, @on),	% normally, a window is protected
					% by its frame, not this time!
	(   send(W, has_send_method, win_handle)
	->  send(W, win_handle, HWND)
	;   send(@(display), inform, 'Bad XPCE version')
	).


		 /*******************************
		 *	 SPECIFIC WINDOWS	*
		 *******************************/

:- pce_begin_class(canvas, picture).

:- pce_global(@canvas_recogniser,
	      new(handler_group(click_gesture(left, '', single,
					      message(@receiver, add_box,
						      @event?position))))).

event(C, Ev:event) :->
	(   send(C, send_super, event, Ev)
	;   send(@canvas_recogniser, event, Ev)
	).

add_box(C, Pos:point) :->
	send(C, display, new(B, box(100, 50)), Pos),
	send(B, recogniser, handler_group(resize_gesture(left),
					  move_gesture(left))).

:- pce_end_class.
